function [ error ] = newmodel(P2,param)
    z=param.z;
    P1=param.P1;
    P4=param.P4;
    ko=param.ko;
    kw=param.kw;
    kg=param.kg;
    g=param.g;
    Cd=param.Cd;
    A=param.A;
    R=param.R;
    T=param.T;
    Mg=param.Mg;
    rhoo=param.rhoo;
    rhow=param.rhow;
    z_valve = param.z_valve;
    fz=param.fz;
    mg=param.mg(P2);

%System equations:
    mo=ko*(P2-P1);
    mw=kw*(P2-P1);
    %mg=kg*(P2-P1)*(P2^(2)-P1^(2));
    mtot=mo+mw+mg;
    D=(mg*R*T)/Mg;
    B=(mo/rhoo)+(mw/rhow);
    

    if z_valve <= 1e-20;  
        P3=P4;
        mtot_vl = 0;
    else
        P3=P2-((mtot*g*P2*z)/(D+B*P2));
        rho_mix3=(mtot)/((D/P3)+B);
        rho_mix4=(mtot)/((D/P4)+B);
        
        if (P3-P4)>=0
            mtot_vl=fz(z_valve)*Cd*A*sqrt(((rho_mix3+rho_mix4)/2)*(P3-P4));
        elseif (P3-P4)<0
            mtot_vl=-fz(z_valve)*Cd*A*sqrt(((rho_mix3+rho_mix4)/2)*(-P3+P4));
        end
    end
    
    
    
    
    error=mtot-mtot_vl;
%MODEL Summary of this function goes here
%   Detailed explanation goes here


end

