function output = newwell_2(z_valve)
   
    param.z_valve = z_valve;
    
%%%%Giving the parameters vaules: 
    param.z  =1000;            % Lenght of pipeline m
    param.P1 =300e5;       % Pressure in reservoir Pa
    param.P4 =100e5;         % Sressure in reservoir Pa
    param.ko =-3854/1e5;         % Slope found from darcy's law
    param.kw =-3634/1e5;       % Slope found from darcy's law
    param.kg =0.0112/(1e5)^3;   % Slope found from darcy's law 
    param.g  =9.8;             % Gravity constant m/s2
    param.Cd =1*84600;              % Valve coeffficient scaled to give m in /d
    param.A  = 5.56*10^(-4);    % Valve cross section area m2
    param.R  =8.314;           % Gas constant J/Kmol
    param.T  =373;             % Temerature assumed constant K   
    param.Mg =16.04*10^(-3);  % Molar mass gas kg/mol
    param.rhoo=800;          % Density of oil kg/m3
    param.rhow=1000;         % Density of water kg/m3
    param.fz = @(z) z;
    %param.fz = @(z) log10(9*z+1);
    param.mg = @(P2) param.kg*(P2-param.P1)*(P2^2-param.P1^2); 
    
   if z_valve <= 1e-10
       P2=param.P1;
       output=[0,0,0,param.P1*1e-5,P2*1e-5,NaN,param.P4*1e-5];
   else
%     P20=250e5;
%     opt=optimoptions(@fsolve,'TolX',1e-9,'TolFun',1e-9);
%     P2 = fsolve(@(P2) newmodel(P2,param), P20,opt);
    P20=250e5;
    P2 = fzero(@(P2) newmodel(P2,param), P20);

    z=param.z;
    P1=param.P1;
    P4=param.P4;
    ko=param.ko;
    kw=param.kw;
    kg=param.kg;
    g=param.g;
    Cd=param.Cd;
    A=param.A;
    R=param.R;
    T=param.T;
    Mg=param.Mg;
    rhoo=param.rhoo;
    rhow=param.rhow;
    z_valve = param.z_valve;
    fz=param.fz;

%System equations:
    mo=ko*(P2-P1);
    mw=kw*(P2-P1);
    mg=param.mg(P2);
    mtot=mo+mw+mg;
    D=(mg*R*T)/Mg;
    B=(mo/rhoo)+(mw/rhow);
    P3=P2-((mtot*g*P2*z)/(D+B*P2));
    rho_mix3=(mtot)/((D/P3)+B);
    rho_mix4=(mtot)/((D/P4)+B);
    mtot_vl=fz(z_valve)*Cd*A*sqrt(((rho_mix3+rho_mix4)/2)*(P3-P4));
    error=mtot-mtot_vl;

    
%    fprintf('param.z_valve: %.2f\n',param.z_valve)
%    fprintf('mo: %.2f, mg: %.2f, mw: %.2f, mtot: %.2f\n',mo,mg,mw,mtot)
%    fprintf('P1: %.2f, P2: %.2f, P3: %.2f, P4: %.2f\n',P1*1e-5,P2*1e-5,P3*1e-5,P4*1e-5)

   
   output=[mo,mg,mw,P1*1e-5,P2*1e-5,P3*1e-5,P4*1e-5];
    end   
end
   
   
