%Estimaton the slope by using a well model where the massflows are assumed
%known, when the pressure in 135 bar, and 0 at reservoir pressure  
%Dencity at stp 
rhoo=0.8;                   %ton/m3
rhow=1;                     %ton/m3
rhog=0.656e-3;              %ton/m3

%Pressure in bar: 
Presb=300;           %bar
Pknownb=150;         %bar

kob=-3080;      %slope oil 
kwb=-964;     %slope water 
kgb1=0.0056;  %ton/bar3 slope gas
kgb2=0.0112;  %ton/bar3 slope gas

Pb=Pknownb:1:Presb; 
mob=kob*(Pb-Presb);            %ton/day
mwb=kwb*(Pb-Presb);            %ton/day ton/bar
mgb1=kgb1.*(Pb-Presb).*(Pb.^2-Presb^2);       %ton/day ton/bar2
mgb2=kgb2.*(Pb-Presb).*(Pb.^2-Presb^2);       %ton/day ton/bar2
figure(1)
plot(Pb,mob,'b',Pb,mwb,'r',Pb,mgb1,'y')
 xlabel('well hole pressure bar')
 ylabel('mass flow ton/day')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% Gas - Oil - Ratio 

%mass flow basis 
GORm1 = mgb1./mob;
GORm2 = mgb2./mob;
%GORm = kgb/kob*(Pb.^2-Presb^2)./(Pb-Presb);
% %flowrate basis
% qob=mob./rhoo;
% qgb=mgb./rhog;
% GORq = qgb./qob;

figure(2)
plot(Pb,GORm1,'b',Pb,GORm2,'r')
 xlabel('well hole pressure bar')
 ylabel('GOR (mg/mo)')

% figure(4)
% plot(Pb,GORq)
%  xlabel('well hole pressure bar')
%  ylabel('GOR (qg/qo)')

% 








